<?php

/**
 * Plugin Name: SmilePay_C2C 
 * Plugin URI: http://www.smilepay.net
 * Description: SmilePay C2C 
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
 * Version: 2.6.12
 */

if(!defined("SMILEPAY_RESPONSE_DECLARE"))
{
    include "smilepay_respond.php";
}

add_action('plugins_loaded', 'SmilePayc2c_gateway_init', 80);



function SmilePayc2c_gateway_init() {
   if (!class_exists('WC_Payment_Gateway')) {
        return;
    }

  

    class WC_SmilePayc2c extends WC_Payment_Gateway {
        public $title;
        public $description;
        public $dcvc;
        public $Rvg2c;
        public $Deadline_date;
        public $Order_OKmain;
        public $reurl;
        public $Verify_key;

        public function __construct() {
            $this->id = 'smilepayc2c';
            $this->icon = apply_filters('woocommerce_SmilePayc2c_icon', plugins_url('log/smilepay.png', __FILE__));
            $this->has_fields = false;
            $this->method_title = __('SmilePayc2c', 'woocommerce');
            // Load the form fields.
            $this->init_form_fields();
            // Load the settings.
            $this->init_settings();
			
            // Define user set variables
            $this->title = $this->settings['title'];
            $this->description = $this->settings['description'];
            $this->dcvc = $this->settings['dcvc'];
            $this->Rvg2c =  $this->settings['Rvg2c'];
			$this->Verify_key = $this->settings['Verify_key'];
			$this->Order_OKmain = $this->settings['Order_OKmain'];
			//$this->reurl = $this->settings['reurl'];
            $this->reurl =get_option('siteurl')."/?smilepay_respond";
            // Actions
            //add_action('init', array(&$this, 'check_SmilePayc2c_response'));
            add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
            add_action('woocommerce_thankyou_'.$this->id, array($this, 'thankyou_page')); 
        }
        /**
         * Initialise Gateway Settings Form Fields
         *
         * @access public
         * @return void
         */
        public function init_form_fields() {  //x]m
		//	$urll=get_option('siteurl')."/?respond";
            $this->form_fields = array(
                'enabled' => array(
                    'title' => __(u2b2("ҥ/"), 'woocommerce'),
                    'type' => 'checkbox',
                    'label' => __(u2b2(' SmilePay WӨfI'), 'woocommerce'),
                    'default' => 'yes'
                ),
                'title' => array(
                    'title' => __(u2b2('D'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2b2('UȦbbɩܪIڤ覡Mte覡D'), 'woocommerce'),
                    'default' => __(u2b2('SmilePay WӨfI'), 'woocommerce')
                ),
                'description' => array(
                    'title' => __(u2b2('Iڤ覡'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2b2('UȦbܥIڤ覡ɩܪФr'), 'woocommerce'),
                    'default' => __(u2b2("SmilePay  WӨfI úO"), 'woocommerce')
                ),
                'dcvc' => array(
                    'title' => __(u2b2('ӮaN'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2b2('жJzSmilePayөN'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Rvg2c' => array(
                    'title' => __(u2b2('ӮaѼƽX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2b2('жJzSmilePayӮaѼƽX'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Verify_key' => array(
                    'title' => __(u2b2('ӮaˬdX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2b2('жJzSmilePayӮaˬdXAˬdXӮaxuIAPIvAнƻsöKJW'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),				
                'Mid_smilepay' => array(
                    'title' => __(u2b2('ӮaҰѼ'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2b2('жJzSmilePaҽXAҽXӮaxu򥻸ƺ޲zvAнƻsöKJWApҽЫOdť'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),				
				'Order_OKmain' => array(
                    'title' => __(u2b2('q榨߫ܰT'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2b2('q榨ܰT'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
				/*'reurl' => array(
                    'title' => __(u2b2('^em'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2b2('^emAбNUCrƻsWؤ(p^eЯdť)</br><font color=red ue size=+1>'.$urll.'</font>', 'woocommerce')),
                    'default' => __('', 'woocommerce')
                ),*/
				'hiddtext' => array(
                    'title' => __(u2b2('WӨfIڪ`Nƶ'), 'woocommerce'),
                    'type' => 'hidden',
                    'description' => __(u2b2("ϥζWӨfIڥ\Aݪ`NHUƶG
												<br><font color='red'>ϥΦҲե}ҡitRt7-11fIڡjteҲաAнT{ҥ</font>												
												<br>1.ХSmilePayӮax}ҨfIڥ\*<a target='_blank' href='http://www.smilepay.net/RVG.ASP'>Ӯax</a>*
												<br>2.*Hfӫ~W*qW١AëDӫ~ӡA]qW<font color='red'>Lе</font>C
												<br>3.bT<font color='red'>pq</font><font color='red'>X</font>Aӫ~ɷ|H²TqC
												<br>4.O̦߭qAЦSmilePayӮaxo<font color='red'>fKNX</font>C
												<br>5.O̦߭qAiܭqƵI<font color='red'>}ҥfKAȳ</font>C																										
												<br>6.бN<font color='red'>fKNX</font>ʷsWܰӫ~ƵAHQO̬dߪyAC
												<br>7.hаѾ\A<font color='red'>SmilePay</font>P<font color='red'>WooCommerceҲջ</font>C
												"), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),            
			);
        }
        /**
         * Admin Panel Options
         * - Options for bits like 'title' and availability on a country-by-country basis
         *
         * @access public
         * @return void
         */
       public function get_SmilePayc2c_args($order) {
            global $woocommerce;

            $paymethod = 'c2c';
            $order_id = $order->id;
			$post_status = $order->post_status;


            $SmilePayc2c_args = array(
                "dcvc" => $this->dcvc,
                'Rvg2c' => $this->Rvg2c,
                "Verify_key" => $this->Verify_key,
			//	"dcvg" => $this->dcvg,
                "payment_type" => $paymethod,
                "od_sob" => $order_id,
				"post_status" => $post_status,
				'Order_OKmain' => $this->Order_OKmain,
				'reurl' => $this->reurl,
				"amt" => round($order->get_total()),
            );
            $SmilePayc2c_args = apply_filters('woocommerce_SmilePayc2c_args', $SmilePayc2c_args);
            return $SmilePayc2c_args;
        }
		
       public function thankyou_page($order_id) {  //^ǰѼ  P   c2c
			global $post, $wpdb, $thepostid, $theorder, $order_status, $woocommerce;
            $order = new WC_Order($order_id);
			// $order = &new WC_Order($order_id);

			$SmilePayc2c_args = $this->get_SmilePayc2c_args($order);
			$order_status=$SmilePayc2c_args['post_status'];
            $pur_name = $order->billing_last_name . $order->billing_first_name;
		if($order_status=='wc-pending')
		{	
			//P_qܬO_T,mW
			/*if(substr($order->billing_phone,0,2)!="09"||mb_strlen($order->billing_phone)!=10){
				$order->update_status('cancelled');
				echo u2b2("<font color=red>q榨ߥ</font><br><br>~TG<br>sqܽпJ(@10X)Aӫ~쩱ANoe²TqC<br>WrPm`XiWL5ӦrC<br><br>ЭsbC");
				addtocart($thepostid);
				exit();
			}	
			if(mb_strlen($order->billing_first_name.$order->billing_last_name)>5){
				$order->update_status('cancelled');
				echo u2b2("<font color=red>q榨ߥ</font><br><br>~TG<br>sqܽпJ(@10X)Aӫ~쩱ANoe²TqC<br>WrPm`XiWL5ӦrC<br><br>ЭsbC");
				addtocart($thepostid);
				exit();
			}*/
			
			//ھڷUվreurlOhttphttps
            if(is_ssl())
                $SmilePayc2c_args['reurl']=str_replace('http://','https://',$SmilePayc2c_args['reurl']);
            else
                $SmilePayc2c_args['reurl']=str_replace('https://','http://',$SmilePayc2c_args['reurl']);	
			//}C2C
			if($SmilePayc2c_args['reurl']!=''){$Vk=$SmilePayc2c_args['reurl']."=".$order->order_key;}else{$Vk='';}

            if(is_ssl())
                $URL = 'https://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
            else
			    $URL = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
            //<SmilePay>item add start
            /*$products="";
            foreach ($order->get_items() as $key => $lineItem) {
                $products .= $lineItem['name'] ."*" .$lineItem['item_meta']['_qty'][0] .",";
            
            }
            $products=trim($products,",");*/

			$cardurl =	'https://ssl.smse.com.tw/ezpos/mtmk_utf.asp?'.
						'Dcvc=' . $SmilePayc2c_args['dcvc'] .
						'&Pay_zg=51' .
						'&Rvg2c=' .  $SmilePayc2c_args['Rvg2c'] .
						'&Od_sob=' .$SmilePayc2c_args['od_sob'].
						'&Pur_name=' .urlencode($pur_name ).
						'&Mobile_number=' .urlencode($order->billing_phone).
						'&Email=' .urlencode($order->billing_email).
						'&Data_id=' . $SmilePayc2c_args['od_sob'].
						'&Amount=' . $SmilePayc2c_args['amt'].
						'&Roturl_status=' . 'woook'.
						'&Roturl=' . $Vk.
						'&MapRoturl=' . urlencode($URL).
						'&Remark=woocommerce';
                        //<SmilePay>item add start
					    //'&Remark='. $products;
                        //<SmilePay>item add end
            //Mobile map start
            $useragent=$_SERVER['HTTP_USER_AGENT'];
            if( preg_match('/Android|iPad|iPhone/i',$useragent))
            {
                $cardurl .="&Logistics_MapType=M";
                          
            }
            //Mobile map end
            $shipping_method = @array_shift($order->get_shipping_methods());
            $shipping_method_id = $shipping_method['method_id'];

            if(class_exists('WC_Smilepayc2cp_Shipping_Method'))
            {
               $methods_arg= WC_Smilepayc2cp_Shipping_Method::getCSVServiceArg($shipping_method_id);
               if($methods_arg)
               {
                   $cardurl .= '&Pay_subzg='.$methods_arg;
               }
            }


                			//qܦѤ			
			$order->update_status('on-hold');			
			header("Location: $cardurl"); 
			exit();	
		}		
		if($order_status=='wc-on-hold'&&$_REQUEST['Classif']=='T')
		{
			$T_Smseid=$_REQUEST['Smseid'];
			$T_Storename=b2u2($_REQUEST['Storename']);
			$T_Storeid=b2u2($_REQUEST['Storeid']);
            $T_Storeaddress = $_REQUEST['Storeaddress'];
            $title =b2u2( $this->title);
            $isRecorded=FALSE;
            //<smilepay> modify address start
            $T_Storename2=$_REQUEST['Storename'];
            if( !empty($T_Storeid) && !empty($T_Storename2) && !empty($T_Storeaddress))
            {
              
                $shipping_addr= $order->shipping_address_1;
                $store_addr=$T_Storeid ." " .$T_Storename2 ." " .$T_Storeaddress;
                if($store_addr != $shipping_addr)
                {
                    //$order->shipping_address_1=$store_addr;
                    $order->set_address(array('address_1'=>$store_addr),'shipping');
                }
                else
                    $isRecorded=TRUE;
                //$order->set_billing_address_1($T_Storeid ." " .$T_Storename ." " .$T_Storeaddress);
            }
            
            //<smilepay> modify address end

            $shipping_method = @array_shift($order->get_shipping_methods());
            $shipping_method_id = $shipping_method['method_id'];
            $storeTypeName=b2u2(WC_Smilepayc2cp_Shipping_Method::getCSVServiceName($shipping_method_id));
			$pay_ok="úO覡G<font color=red>$title</font><br>fWӡG<font color=red>$storeTypeName</font><br>fG<font color=red>".$T_Storename.$T_Storeid."</font><br>";
            $pay_ok .= "a}G<font color=red>".b2u2($T_Storeaddress)."</font><br>";
            $pay_ok .= "fHmWG<font color=red>".b2u2($pur_name )."</font><br>";
            $pay_ok .= "fHqܡG<font color=red>".b2u2($order->billing_phone)."</font><br>";
			if(!$isRecorded)
                $order->add_order_note(u2b2($pay_ok),"1");
			$ordertext="ФŧRTAtRtSmilePaylܽXG".$T_Smseid;
            if(!$isRecorded)
			    $order->add_order_note(u2b2($ordertext),"0");
			echo u2b2("<font color='red' size='3'>`NGqwߡAݰӮaHfAӫ~FN|H²TqIڨf</font><br><br>");
			echo u2b2("<h1>úOT</h1>".$pay_ok);
			echo "<br><br>".$SmilePayc2c_args['Order_OKmain'];

			if(!$isRecorded)
            {
                $cccurl="http://ssl.smse.com.tw/api/C2CPayment.asp?smseid=".$T_Smseid."&dcvc=".$SmilePayc2c_args['dcvc']."&types=web&Verify_key=".$SmilePayc2c_args['Verify_key'];
                $cccurl_customer= get_admin_url()."post.php?Page=smilepay_c2c_shipping_gen&order_id=$order_id&smseid=".$T_Smseid."&dcvc=".$SmilePayc2c_args['dcvc']."&Verify_key=".$SmilePayc2c_args['Verify_key'];
                $shipping_method = @array_shift($order->get_shipping_methods());
                $shipping_method_id = $shipping_method['method_id'];
                if(class_exists('WC_Smilepayc2cp_Shipping_Method'))
                {
                   $methods_arg= WC_Smilepayc2cp_Shipping_Method::getCSVServiceArg($shipping_method_id);
                   if($methods_arg)
                   {
                        $cccurl .= "&Pay_subzg=".$methods_arg;
                         //$cccurl_customer .= "&Pay_subzg=".$methods_arg;
                   }
                }
                
                
                //gJqúO-O
			    $scvurls="IͥfKAȳ<br>*<a target='_blank' href='".$cccurl."'>fKAȳ</a>*<br>*<a href='$cccurl_customer"."'>NfKAȳgJƵ</a>*";
			
                $order->add_order_note(u2b2($scvurls),"0");
            }
          
		}
        else
        {
            echo u2b2("<font color='red' size='3'>pѰO<u>úOT</u>ЦۤWC<u>b]w->q->˵</u></font>");
        }
}
        /**
         * Process the payment and return the result
         *
         * @access public
         * @param int $order_id
         * @return array
         */
        public function process_payment($order_id) {
			$order = new WC_Order( $order_id );

            if(is_null($this->dcvc) || empty($this->dcvc) ||
               is_null($this->Verify_key) || empty($this->Verify_key) ||
               is_null($this->Rvg2c) || empty($this->Rvg2c)
                )
            {
                wc_add_notice(u2b2("<br>tRtӮaѼƿ~AлPӮapô<br>") , 'error' );
                return;
            }
			
			$order->reduce_order_stock();
			return array(
				'result' 	=> 'success',
				'redirect'	=> $this->get_return_url( $order )
			);
        }
        public function is_available() {
		    $order          = null;
		    $needs_shipping = false;

		    // Test if shipping is needed first
		    if ( WC()->cart && WC()->cart->needs_shipping() ) {
			    $needs_shipping = true;
		    } elseif ( is_page( wc_get_page_id( 'checkout' ) ) && 0 < get_query_var( 'order-pay' ) ) {
			    $order_id = absint( get_query_var( 'order-pay' ) );
			    $order    = wc_get_order( $order_id );

			    // Test if order needs shipping.
			    if ( 0 < sizeof( $order->get_items() ) ) {
				    foreach ( $order->get_items() as $item ) {
					    $_product = $item->get_product();
					    if ( $_product && $_product->needs_shipping() ) {
						    $needs_shipping = true;
						    break;
					    }
				    }
			    }
		    }

		    $needs_shipping = apply_filters( 'woocommerce_cart_needs_shipping', $needs_shipping );

		    // Virtual order, with virtual disabled
		    if ( ! $needs_shipping ) {
			    return false;
		    }

		    return parent::is_available();
	    }
        function selectedIcon($type='711')
        {
            if(strtoupper($type) == 'FAMI')
                $this->icon = apply_filters('woocommerce_SmilePayc2c_icon', plugins_url('log/famiport.jpg', __FILE__));
            else
                $this->icon = apply_filters('woocommerce_SmilePayc2c_icon', plugins_url('log/smilepay.png', __FILE__));
        }
    }
    /**
     * Add the gateway to WooCommerce
     *
     * @access public
     * @param array $methods
     * @package		WooCommerce/Classes/Payment
     * @return array
     */
    function add_SmilePayc2c_gateway($methods) {
        $methods[] = 'WC_SmilePayc2c';
        return $methods;
    }


  

    add_filter('woocommerce_payment_gateways', 'add_SmilePayc2c_gateway');


    if(is_admin())
    {
        global $pagenow;
        add_action('admin_notices', 'smilepay_c2c_shipping_error_show' );
        if($pagenow=='post.php' && $_GET['Page']=='smilepay_c2c_shipping_gen')
        {
            smilepay_c2c_shipping_gen();
        }
    }
}
    function smilepay_c2c_shipping_error_show()
    {
        $error="";
        if(isset($_COOKIE['smilepay_c2c_admin_shipping_error']))
        {
             $error= $_COOKIE['smilepay_c2c_admin_shipping_error'];
             unset($_COOKIE['smilepay_c2c_admin_shipping_error']);
             setcookie('smilepay_c2c_admin_shipping_error', '', time() - 30 );
        }
            
        if($error)
        {
            echo "<div class='notice notice-error'><p>$error</p></div>";
        }

    }

    function smilepay_c2c_shipping_gen()
    {
        
        if(
            !isset($_GET['smseid'])  || !$_GET['smseid'] ||
            !isset($_GET['dcvc'])  || !$_GET['dcvc'] ||
            !isset($_GET['Verify_key'])  || !$_GET['Verify_key'] ||
            !isset($_GET['order_id'])  || !$_GET['order_id'] 
        )
        {
            setcookie("smilepay_c2c_admin_shipping_error",  u2b2("~,Ѽƿ~"), time()+30);
            wp_redirect($order_url);
            exit;
        }

        $order_id = $_GET['order_id'];
        $order_url =  get_admin_url()."post.php?post=$order_id&action=edit";
        include_once('smilepayc2cp.php');
        if(!class_exists('WC_Smilepayc2cp_Shipping_Method'))
            Smilepayc2cp_shipping_method_init();
        $smilepayc2cp_obj=new WC_Smilepayc2cp_Shipping_Method();
        if(! $smilepayc2cp_obj->isSelectedSmilepayC2Cp($order_id))
        {
          
            setcookie("smilepay_c2c_admin_shipping_error",  u2b2("~,ӭq"), time()+30);
            wp_redirect($order_url);
            exit;
            
        }

      


        $cccurl="https://ssl.smse.com.tw/api/C2CPayment.asp";
        $postdata="types=xml&smseid=".$_GET['smseid']."&dcvc=".$_GET['dcvc']."&Verify_key=".$_GET['Verify_key'];

        $order = new WC_Order($order_id);
        $shipping_method = @array_shift($order->get_shipping_methods());
        $shipping_method_id = $shipping_method['method_id'];

        foreach($shipping_method['item_meta_array']  as $items)
        {
             
            if($items->key=='method_id')
            {
                $shipping_method_id = $items->value;
                break;
            }

        }

        if(class_exists('WC_Smilepayc2cp_Shipping_Method'))
        {
            $methods_arg= WC_Smilepayc2cp_Shipping_Method::getCSVServiceArg($shipping_method_id);
            if($methods_arg)
            {
                $postdata .= "&Pay_subzg=".$methods_arg;
            }
        }

        $ch1 = curl_init();
	    curl_setopt($ch1, CURLOPT_URL, $cccurl);
	    curl_setopt($ch1, CURLOPT_VERBOSE, 1);
	    curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, FALSE);
	    curl_setopt($ch1, CURLOPT_SSL_VERIFYHOST, FALSE);
	    curl_setopt($ch1, CURLOPT_POST, 1);
	    curl_setopt($ch1, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch1, CURLOPT_POSTFIELDS, $postdata);
	    $string_1 = curl_exec($ch1);
	    curl_close($ch1);
	    $xmls = simplexml_load_string($string_1);
	    $Status_1 = $xmls->Status;

        if( empty($xmls))
        {
            setcookie("smilepay_c2c_admin_shipping_error", u2b2("~"), time()+30);
            wp_redirect($order_url);
            exit;
        }


	    if($Status_1=="1")
	    {
             
             $notes=$order->get_customer_order_notes();
             $queryShipmentUrl = WC_Smilepayc2cp_Shipping_Method::getQueryShipmentUrl($shipping_method_id);
             $comment = u2b2("fKXG".$xmls->paymentno . $xmls->validationno."<br>*<a target='_blank' href='$queryShipmentUrl'>d߭</a>*");
            
             foreach($notes as $note)
             {
                 if($note->comment_content == $comment)
                 {    
                    setcookie("smilepay_c2c_admin_shipping_error", u2b2("wg͸ӳƵ"), time()+30);
                    wp_redirect($order_url);
                    exit;
                    return;
                 }
                   

             }
           
             $order->add_order_note($comment,"1");
          //   do_action( 'smilepay_c2c_shippingpay_create_shipping_trick',$order_id, $xmls->paymentno . $xmls->validationno, $_GET['smseid'] );
             wp_redirect($order_url);
             exit;
        }
        else
        {
            setcookie("smilepay_c2c_admin_shipping_error", u2b2(sprintf("~,~NX:%s",$xmls->Status)), time()+30);
            wp_redirect($order_url);
            exit;
        }
      
    }

function u2b2($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2u2($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
function addtocart($thepostid)
{
global $post, $wpdb, $thepostid, $theorder, $order_status, $woocommerce;
/*$sqlll="SHOW TABLES LIKE  '%comments%'";
$recheck=mysql_query($sqlll);
$row = mysql_fetch_array($recheck);
$tablelist=$row[0];
$tablelist=explode('_',$tablelist);
$tablelist=$tablelist[0].'_';*/
$tablelist= $wpdb->prefix;
//ӫ~q渹
$order_items = $wpdb->get_results( "SELECT * FROM `".$tablelist."woocommerce_order_items"."` WHERE `order_id` = '$thepostid' " );
	foreach ( $order_items as $order_no ) 
	{
		$vr =$order_no->order_item_id;
		//ӫ~ID,ƶq
		if($order_no->order_item_type=="line_item"){
			$order_itemmeta = $wpdb->get_results( "SELECT * FROM `".$tablelist."woocommerce_order_itemmeta"."` WHERE `order_item_id` = '$vr' "  );
			foreach ( $order_itemmeta as $order_id ) 
			{	
				if($order_id->meta_key=="_product_id"){$order_add_id=$order_id->meta_value;}
				if($order_id->meta_key=="_qty"){$order_add_num=$order_id->meta_value;}
			}
			WC()->cart->add_to_cart($order_add_id,$order_add_num);
		}
	}
}








?>